class games.MovingSceneElement
{
   var wMin;
   var wMax;
   var hMin;
   var hMax;
   var wall1;
   var slope1;
   var wall2;
   var slope2;
   var wall1_lastHeight = 0;
   var wall2_lastHeight = 0;
   var doWall1 = null;
   var doWall2 = null;
   function MovingSceneElement(w0, w1, h0, h1, el0, sl0, el1, sl1)
   {
      this.wMin = w0;
      this.wMax = w1;
      this.hMin = h0;
      this.hMax = h1;
      this.wall1 = el0;
      this.slope1 = sl0;
      this.wall2 = el1;
      this.slope2 = sl1;
      this.doWall1 = this.createWall1;
      if(this.wall2 == undefined)
      {
         this.doWall2 = null;
      }
      else
      {
         this.doWall2 = this.createWall2;
      }
   }
   function createWall(_MC, _w, el_width, el_newheight, _lastHeight, wall, slope)
   {
      var tMC1;
      var tMC2;
      var _depth = _MC.getNextHighestDepth();
      tMC1 = _MC.attachMovie(wall,"w" + _depth,_depth,{_x:_w,_width:el_width});
      if(_lastHeight <= el_newheight)
      {
         tMC1._height = _lastHeight;
      }
      else
      {
         tMC1._height = el_newheight;
      }
      if(_lastHeight != el_newheight)
      {
         _depth++;
         tMC2 = _MC.attachMovie(slope,"s" + _depth,_depth,{_x:_w,_y:tMC1._height,_width:el_width});
         if(_lastHeight < el_newheight)
         {
            tMC2._height = el_newheight - _lastHeight;
            tMC2._x += tMC2._width;
            tMC2._xscale = - tMC2._xscale;
         }
         tMC2._height = _lastHeight - el_newheight;
      }
      return [el_newheight,tMC1,tMC2];
   }
   function createWall1(_MC, _w, el_width, use_random, use_minimum)
   {
      var h_delta = this.hMax - this.hMin;
      var _h = this.hMin + random(h_delta);
      var output = this.createWall(_MC,_w,el_width,_h,this.wall1_lastHeight,this.wall1,this.slope1);
      this.wall1_lastHeight = output[0];
      return {tMC1:output[1],tMC2:output[2]};
   }
   function createWall2(_MC, _w, el_width)
   {
      var h_delta = this.wall1_lastHeight - this.hMin;
      var _h = this.hMin + random(h_delta);
      var output = this.createWall(_MC,_w,el_width,_h,this.wall2_lastHeight,this.wall2,this.slope2);
      this.wall2_lastHeight = output[0];
      return {tMC1:output[1],tMC2:output[2]};
   }
   function createElement(_MC)
   {
      var _w = _MC._width;
      var el_width = this.wMin + random(this.wMax - this.wMin);
      var wall1 = this.doWall1(_MC,_w,el_width);
      var wall2 = this.doWall2(_MC,_w,el_width);
      return {width:el_width,height:this.wall1_lastHeight};
   }
}
